pro boundaries,x,u,fixed=fixed,korevaar=korevaar,top=top,debug=debug
;
; +
;  boundary conditions
;  routine replaces the first and last values using either
;  fixed or Korevaar and van Leer BCs.
; -
;
@common
uold=u
nx=n_elements(x)
;
y=x
w=u
sign=1
if(n_elements(top) ne 0) then begin 
   w=reverse(w,2)
   w(1,*)=-w(1,*)  ; change sign of velocity, needed to get symmetry
   y=reverse(x)
;   sign=-1
endif
;
;
if(n_elements(korevaar) ne 0) then begin 
;
; return Korevaar and van Leer (1988) characteristic BCs
;
   q=pt(w)
   p=reform(q(0,*))
   cs=csound(w)
   v=reform(w(1,*)/w(0,*))
;
; eq 87
;
   gamma=param.gamma
   a1=(y[1]-y[0])/(y[2]-y[1])*(cs[2]/gamma*alog(p[1]/p[2]) -(v[1]-v[2]))
;
;  C+ and C- characteristic extrapolants
;
   pl=exp( (gamma*(a1+v[0]-v[1]) + cs[0]*alog(p[0])+cs[1]*alog(p[1]))/(cs[0]+cs[1]))
   vl=v[0]-cs[0]/gamma*alog(pl/p[0])
;
; C0 characteristic
   if(vl*sign gt 0.) then cl=cs[0]+ (gamma-1)/2/gamma*cs[0]*alog(pl/p[1])
   a2=0.
   if(vl*sign le 0.) then begin 
      a2=0.5*(cs[2]/gamma*alog(p[1]/p[2]) - 2/(gamma-1.) *(cs[1]-cs[2]))
      cl=cs[1]+ (gamma-1)/2*(cs[1]/gamma*alog(pl/p[1]) - a2)
   endif
;   if(n_elements(top) ne 0) then print,'top a1 a2',a1,a2 else print,'bot a1 a2',a1,a2
;
; transform back to conserved variables
;
   rhol=gamma*pl/cl/cl
   el=pl/(gamma-1)+ rhol*vl*vl/2
;
   w(0,0)=rhol &   w(1,0)=rhol*vl &    w(2,0)=el
;
endif else if (n_elements(fixed) ne 0) then begin 
;
;  FIXED BCs
;
   w(0:2,0)=fixed(0:2)
endif else message,'must set korevaar or fixed'
;
if(n_elements(top) ne 0) then begin 
   u=reverse(w,2) 
   u(1,*)=-u(1,*)
endif else begin 
   u=w
endelse
;
;if((n_elements(top) ne 0) and max(abs(u(1,*)/uold(1,*)-1)) gt 1.e-4) then begin 
;   print,'w'
;   print,w(*,0:2)
;   print,'u'
;   print,u(*,0:2)
;   str='' & read,str
;endif
;
;
return
end
