;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
function delubar,u,limiter=limiter
;
; slope limiter
;
;
nx=(size(u))(2)
z=u*0.d0
j=1+indgen(nx-2)
m=u-shift(u,[0,1])  ; gradient j-1/2
m=m(*,j)
p=shift(u,[0,-1])-u   ; gradient j+1/2
p=p(*,j)
s=sgn(p)
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; LIMITERS:
case limiter of
   'minmod': z(*,j)=minmod(m,p)
   'woodward': z(*,j)=minmod(2*m,2*p,0.5*(m+p))
   'umist': z(*,j)=minmod(2*m,2*p,0.25*(3*m+p),0.25*(m+3.*p))
   'superbee': z(*,j)=s* ( 0.d0 > ((2*abs(p) < s*m) > (abs(p) < 2*s*m)))
   else:    message,'limiter '+limiter+' not known'
endcase
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

return,z
end
