function driverc,u,x,t
;+
; Additional driving terms at time t 
;-
@common
common burst5,told,xmn,xmx
g=u*0.d0
t1=10 & t2=t1+15 & t3=t2+15
if(n_elements(told) eq 0) then told=t
;
if(t lt t1 or t gt t3) then return,g ; do nowt
;
; Track blob  (get new xmn, xmx)
;
vel=u(1,*)/u(0,*)
xmn1=2.0e8 & xmx1=2.4e8  & f1=3. & f2=30. ; chromospheric  latest OK
;xmn1=1.8e8 & xmx1=2.3e8  & f1=3. & f2=300. ; chromospheric  original submissin
if(t lt t1+.1) then begin ; start tracking blob
   xmn=xmn1 & xmx=xmx1
endif
dt=t-told
tabinv,x,xmn,ii
xmn=xmn+ vel(ii)*dt
tabinv,x,xmx,ii
xmx=xmx+ vel(ii)*dt
;
;  do driving
;
okx=where(x gt (xmn) and x lt (xmx))
profile=1.
av=(xmn+xmx)/2.
profile=abs(x(okx)-av)
delta=(xmx-xmn)/3.
profile=exp(-profile*profile/delta/delta) ; 
profile/=max(profile)
if(t lt t2) then begin 
;
; initial period, accn and a bit of heating
;
; extra force, 2 km/s2 in addition to g, will give v=at=40km/s for t=20s
;
   g(1,okx)= (2.d5-gg)*reform(u(0,okx))*profile
   g(2,okx)= (u(3,okx)*param.heatn*f1 + u(4,okx)*param.heatp*f1) * profile ;
endif else begin 
;
; second period, coasting  and a lot of heating
;
   g(2,okx)= (u(3,okx)*param.heatn + u(4,okx)*param.heatp) * f2* profile
endelse
;
told=t
return,g
end
