pro energyb,x,u

@common

!p.multi=[0,2]
title=['flux divergences erg/cm3/s', 'inverse time scales']

pp=pt(u)
t=reform(pp(1,*))
p=reform(pp(0,*))

qh=param.heatp*u(4,*) + param.heatn*u(3,*)
qr=-radlossu(u)
qc=deriv(x,fcond(x,t))          ; conductive losses

vel=u(1,*)/u(0,*)
;
pe=u(1,*)*gg
egas= -deriv(x,reform((u(2,*)+p)*vel))
tt=qh+qr+qc+egas+pe
mx=tt*0.
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; plots
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

xmx=0.6
k=where(x/1.e8 gt xmx and x/1.e8 lt 10)
;

plot,x(k),tt(k),/ylog,lines=0,yr=[1.e-8,1.e2],title=title(0),xtitl='T [K]',xr=[0.,3.e8]

oplot,x(k),-tt(k),lines=0;,psym=-1
oplot,x(k),-qr(k),lines=2,ps=-1
oplot,x(k),qc(k),lines=3 & oplot,x(k),-qc(k),lines=3,ps=-1
oplot,x(k),pe(k),lines=4 & oplot,x(k),-pe(k),lines=4,ps=-1
oplot,x(k),qh,lines=1,ps=0
mx = mx > qh
mx = mx > abs(qr)
mx = mx > abs(qc)
mx = mx > abs(pe)
mx = mx > abs(qh)

legend,/top,/right,lines=[0,1,2,3,4],['sum','mech. heating','rad. losses','conduction','pe']
   
plot,x(k),u(2,k)/mx(k),title='Energy relaxation time [s]',yran=[1.e-4,1.e4],/ylog,xr=[.1e8,2.e8]
oplot,x(k),u(2,k)/abs(tt(k)),lines=1
;print,minmax(tscale), median(tscale),form='(3(1x,f11.2))'
!p.multi=0
;str='' & read,str
return
end
