function impstep,x,u,dt,rhs,indx
@common
;+
; implicit step, using diagonal part of Jacobian only
;-
dx=x(1)-x(0)
delta=1.d-3
answer=u*0.d0
a=size(u) & ny=a(1) & nx=a(2)
du=u*delta
k=where(du(1,*) eq 0.,nzero)
if(nzero ne 0) then du(1,k)=1.d4*u(0,k)  ; g cm-3 cm/s
dfdu= (flux(x,u+du/2)-flux(x,u-du/2))/du  ; numerical deriv
;
if(n_elements(indx) eq 0) then indx=indgen(ny)
n=n_elements(indx)
okx=1+indgen(nx-2)
for ii=0,n-1 do begin 
   i=indx[ii]
   df=reform(dfdu(i,okx))       ;  diagonal part of Jacobian
   a=-dt/dx*df/2.
   c=-a
   b=1.+dt*deriv(x(okx),df)
   r=reform(rhs(i,okx))
   answer(i,okx)=trisol(a,b,c,r,/double)       ; this is u(n+1)-u(n)
endfor
return,answer
end
