;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
pro tvdlf,x,u,dt,t,pdelta=pdelta
;+
; first order in time TVDLF scheme, first or 2nd order in space
;-
@common
;   
pdelta=0
a=size(u)
ny=a(1) & nx=a(2)
;
; uniform grid assumed
;
dx=x(1)-x(0)
;
; delta ubar 4.16 of Toth
;
dub=delubar(u,limiter=param.limiter)
;
; fluxes at cell interfaces, eqns. 4.4 4.5
;
sh=[0,1]
;
; second order spatial accuracy, eq. 4.8, set sec=1.0
;
; for first order set sec=0.
sec=0.  ; first order only.   
left=u+.5*dub*sec
right=shift(u-0.5*dub*sec,-sh)
;
fp= (flux(x,left)+flux(x,right))*.5d0
fm= shift(fp,sh)
;
; propagation speed, arithmetic mean
;
cmax=u*0.
av=(u+shift(u,-sh))/2.
c=csound(av) ;+ abs(av(1,*)/av(0,*))
for i=0,ny-1 do cmax(i,*)=c  ; orig
;for i=1,2 do cmax(i,*)=c   ; p, E
;cmax(0,*)=abs(u(1,*)/u(0,*))
;for i=3,ny-1 do cmax(i,*)=cmax(0,*)   
phip=dt/dx*cmax*(right-left)
phim=shift(phip,sh)
;
; eq. 4.3
;
xtra=call_function(param.driver,u,x,t)
new=u - dt/dx*(fp-fm) + 0.5*(phip-phim) + (source(u)+xtra)*dt
bound,x,new
u=new
return 
end
