function seqtri,element,z,temp,u=u
;+
; returns coronal ionization eqm normalized to total=1
; using algebraic tri-diagonal solver for the atomic systems.
; inputs:
;    element   either e.g. 2 or 'He'
;    u  solution vector
;    z   ions of element 'element' to be solved for
;    t   electron temperature
;-
n=atomn(element,/num)
nz=n_elements(z)
nt=n_elements(temp)
uout=dblarr(nz,nt)
spec=specno(element,states(),iy)  ; find indices (iy)/ions (spec) of those ions to be computed
totn=1.d0
;
uout[0,*]=1.d0
for ii=z(0),z(nz-1)-1 do begin 
   rates,n,ii,temp,ion,rec,u=u
   ij=ii-z(0)
   uout(ij+1,*)=uout(ij,*)*reform(ion/rec)
endfor

x=totn/total(uout,1)
for ii=z(0),z(nz-1) do begin 
   ij=ii-z(0)
   uout(ij,*)=uout(ij,*)*x
endfor
;
return,uout
end


