function source,u
;+
; explicit sources to be integrated up on rhs of advection equations
;-
@common
;
;
g=u*0.d0
p=pt(u)
t=reform(p(1,*))
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; force due to gravity
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
g(1,*)= gg*reform(u(0,*))           
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; heating
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; g(2,*) = 3.d-23*n*n  ; Hansteen version
; Anderson and Athay, Q= 1.e-14 erg/atom/s. 
; g(2,*)= 1.d-14*(u(4,*)*heatp+u(3,*)*heatn)
;
g(2,*)= u(3,*)*param.heatn + u(4,*)*param.heatp
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; cooling
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
nne=nelec(u)  ; 
g(2,*) -= radlossu(u)
;
g(2,*) += u(1,*)*gg  ; rate of change of potential energy
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; elemental number densities
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;
a=size(u)
desc=states()
;
for elem=0,n_elements(param.ielements)-1 do begin  ; loop over elements
   el=param.ielements(elem)
   spec=specno(param.elements(elem),desc,index)
   nsp=n_elements(spec)-1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  first ion stage
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
   i=0 & j=index(i) & sp=spec(i)
   rates,el,sp,t,ir,rr,u=u & ir *=nne & rr *=nne
   g(j,*)= u(j+1,*)*rr - u(j,*)*ir
   rrold=rr & irold=ir
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;  intermediate   
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
   for i=1,nsp-1 do begin ; loop over ions
      j=index(i) & sp=spec(i)
      rates,el,sp,t,ir,rr & ir *=nne & rr *=nne
      g(j,*)=  u(j-1,*)*irold + u(j+1,*)*rr - u(j,*)*(ir+rrold)
      rrold=rr & irold=ir
   endfor
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; last ion stage
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
   i=nsp & j=index(i) & sp=spec(i)
   g(j,*)= -u(j,*)*rrold + u(j-1,*)*irold
endfor
;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
g *= param.source_mult
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
return,g
end
