pro timestep,x,uold,u,dt,cfl
;+
; computes new timestep depending on 
;   - courant condition
;   - changes between u and uold.
; NOTE:  this is also done in the TVDLF procedure IF second order is
; used. 
;-
@common
;
a=size(u) & nx=a(2)
dx=x(1)-x(0)
j=2+indgen(nx-3)
cs=csound(u)
xx=changes(u,uold,/notrace) 
if(xx gt .1) then begin 
   slow=param.slowdown
   param.slowdown=(param.slowdown*(1.+xx) < 5.)
;   if(xx gt 1.) then print,'slowdown was ',slow, ' is now ', param.slowdown
endif
cfl=min(dx/cs(j)*param.courant_n) 
dt= cfl/param.slowdown > param.tsmall
;
return
end
